BTCPayServer/Models/ServerViewModels/EmailsViewModel.cs
using System.ComponentModel.DataAnnotations;
using BTCPayServer.Services.Mails;

namespace BTCPayServer.Models.ServerViewModels
{
    public class EmailsViewModel
    {
        public EmailsViewModel()
        {

        }
        public EmailsViewModel(EmailSettings settings)
        {
            Settings = settings;
            PasswordSet = !string.IsNullOrEmpty(settings?.Password);
        }
        public EmailSettings Settings
        {
            get; set;
        }
        public bool PasswordSet { get; set; }
        [EmailAddress]
        [Display(Name = "Test Email")]
        public string TestEmail
        {
            get; set;
        }
    }
}

BTCPayServer/Models/ServerViewModels/LightningWalletServices.cs
namespace BTCPayServer.Models.ServerViewModels
{
    public class LightningWalletServices
    {
        public string ServiceLink { get; set; }
        public bool ShowQR { get; set; }
        public string WalletName { get; internal set; }
    }
}

BTCPayServer/Models/ServerViewModels/LndSeedBackupViewModel.cs
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace BTCPayServer.Models.ServerViewModels
{
    public class LndSeedBackupViewModel
    {
        public bool IsWalletUnlockPresent { get; set; }

        public string WalletPassword { get; set; }

        public string Seed { get; set; }

        public bool Removed { get; set; }
        public async Task<bool> RemoveSeedAndWrite(string lndSeedFilePath)
        {
            var removedDate = DateTime.UtcNow.ToString("yyyy-MM-dd HH:mm:ssZ", CultureInfo.InvariantCulture);
            var seedFile = new LndSeedFile
            {
                wallet_password = WalletPassword,
                cipher_seed_mnemonic = new List<string> { $"Seed removed on {removedDate}" }
            };
            var json = JsonConvert.SerializeObject(seedFile);
            try
            {
                await File.WriteAllTextAsync(lndSeedFilePath, json);
                return true;
            }
            catch
            {
                // file access exception and such
                return false;
            }
        }


        public static LndSeedBackupViewModel Parse(string lndSeedFilePath)
        {
            try
            {
                if (!String.IsNullOrEmpty(lndSeedFilePath) && File.Exists(lndSeedFilePath))
                {
                    var unlockFileContents = File.ReadAllText(lndSeedFilePath);
                    var unlockFile = JsonConvert.DeserializeObject<LndSeedFile>(unlockFileContents);
#pragma warning disable CA1820 // Test for empty strings using string length
                    if (unlockFile.wallet_password == string.Empty)
#pragma warning restore CA1820 // Test for empty strings using string length
                    {
                        // Nicolas stupidinly deleted the password, so we should use the default one here...
                        unlockFile.wallet_password = "hellorockstar";
                    }
                    if (unlockFile.wallet_password != null)
                    {
                        return new LndSeedBackupViewModel
                        {
                            WalletPassword = unlockFile.wallet_password,
                            Seed = string.Join(' ', unlockFile.cipher_seed_mnemonic),
                            IsWalletUnlockPresent = true,
                            Removed = unlockFile.cipher_seed_mnemonic.Count == 1
                        };
                    }
                }
            }
            catch
            {
            }

            return new LndSeedBackupViewModel();
        }

        private class LndSeedFile
        {
            public string wallet_password { get; set; }
            public List<string> cipher_seed_mnemonic { get; set; }
        }
    }
}

BTCPayServer/Models/ServerViewModels/LndServicesViewModel.cs
using System.ComponentModel.DataAnnotations;

namespace BTCPayServer.Models.ServerViewModels
{
    public class LndServicesViewModel
    {
        public string Host { get; set; }
        public bool SSL { get; set; }
        public string Macaroon { get; set; }
        public string AdminMacaroon { get; set; }
        public string ReadonlyMacaroon { get; set; }
        public string InvoiceMacaroon { get; set; }
        public string CertificateThumbprint { get; set; }
        [Display(Name = "GRPC SSL Cipher suite (GRPC_SSL_CIPHER_SUITES)")]
        public string GRPCSSLCipherSuites { get; set; }
        public string QRCode { get; set; }
        public string QRCodeLink { get; set; }
        [Display(Name = "REST Uri")]
        public string Uri { get; set; }
        public string ConnectionType { get; internal set; }
    }
}

BTCPayServer/Models/ServerViewModels/LogsViewModel.cs
using System.Collections.Generic;
using System.IO;

namespace BTCPayServer.Models.ServerViewModels
{
    public class LogsViewModel
    {
        public List<FileInfo> LogFiles { get; set; } = new List<FileInfo>();
        public string Log { get; set; }
        public int LogFileCount { get; set; }
        public int LogFileOffset { get; set; }
    }
}

BTCPayServer/Models/ServerViewModels/MaintenanceViewModel.cs
using System.ComponentModel.DataAnnotations;

namespace BTCPayServer.Models.ServerViewModels
{
    public class MaintenanceViewModel
    {
        [Display(Name = "Change domain")]
        public string DNSDomain { get; set; }
        public bool CanUseSSH { get; internal set; }
    }
}

BTCPayServer/Models/ServerViewModels/SSHServiceViewModel.cs
namespace BTCPayServer.Models.ServerViewModels
{
    public class SSHServiceViewModel
    {
        public string CommandLine { get; set; }
        public string Password { get; set; }
        public string KeyFilePassword { get; set; }
        public bool HasKeyFile { get; set; }
        public string SSHKeyFileContent { get; set; }
    }
}

BTCPayServer/Models/ServerViewModels/ServicesViewModel.cs
using System.Collections.Generic;
using BTCPayServer.Configuration;

namespace BTCPayServer.Models.ServerViewModels
{
    public class ServicesViewModel
    {

        public class OtherExternalService
        {
            public string Name { get; set; }
            public string Link { get; set; }
        }

        public List<ExternalService> ExternalServices { get; set; } = new List<ExternalService>();
        public List<OtherExternalService> OtherExternalServices { get; set; } = new List<OtherExternalService>();
        public List<OtherExternalService> TorHttpServices { get; set; } = new List<OtherExternalService>();
        public List<OtherExternalService> TorOtherServices { get; set; } = new List<OtherExternalService>();
        public List<OtherExternalService> ExternalStorageServices { get; set; } = new List<OtherExternalService>();
    }
}

BTCPayServer/Controllers/ServerController.cs
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Mail;
using System.Threading.Tasks;
using BTCPayServer.Abstractions.Extensions;
using BTCPayServer.Abstractions.Models;
using BTCPayServer.Configuration;
using BTCPayServer.Data;
using BTCPayServer.Events;
using BTCPayServer.HostedServices;
using BTCPayServer.Hosting;
using BTCPayServer.Logging;
using BTCPayServer.Models;
using BTCPayServer.Models.AccountViewModels;
using BTCPayServer.Models.ServerViewModels;
using BTCPayServer.Services;
using BTCPayServer.Services.Apps;
using BTCPayServer.Services.Mails;
using BTCPayServer.Services.Stores;
using BTCPayServer.Storage.Models;
using BTCPayServer.Storage.Services;
using BTCPayServer.Storage.Services.Providers;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.AspNetCore.Routing;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Logging;
using NBitcoin;
using NBitcoin.DataEncoders;
using Renci.SshNet;
using AuthenticationSchemes = BTCPayServer.Abstractions.Constants.AuthenticationSchemes;

namespace BTCPayServer.Controllers
{
    [Authorize(Policy = BTCPayServer.Client.Policies.CanModifyServerSettings,
               AuthenticationSchemes = AuthenticationSchemes.Cookie)]
    public partial class ServerController : Controller
    {
        private readonly UserManager<ApplicationUser> _UserManager;
        readonly SettingsRepository _SettingsRepository;
        private readonly NBXplorerDashboard _dashBoard;
        private readonly StoreRepository _StoreRepository;
        readonly LightningConfigurationProvider _LnConfigProvider;
        private readonly TorServices _torServices;
        private readonly BTCPayServerOptions _Options;
        private readonly AppService _AppService;
        private readonly CheckConfigurationHostedService _sshState;
        private readonly EventAggregator _eventAggregator;
        private readonly CssThemeManager _cssThemeManager;
        private readonly StoredFileRepository _StoredFileRepository;
        private readonly FileService _FileService;
        private readonly IEnumerable<IStorageProviderService> _StorageProviderServices;

        public ServerController(UserManager<ApplicationUser> userManager,
            StoredFileRepository storedFileRepository,
            FileService fileService,
            IEnumerable<IStorageProviderService> storageProviderServices,
            BTCPayServerOptions options,
            SettingsRepository settingsRepository,
            NBXplorerDashboard dashBoard,
            IHttpClientFactory httpClientFactory,
            LightningConfigurationProvider lnConfigProvider,
            TorServices torServices,
            StoreRepository storeRepository,
            AppService appService,
            CheckConfigurationHostedService sshState,
            EventAggregator eventAggregator,
            CssThemeManager cssThemeManager)    
        {
            _Options = options;
            _StoredFileRepository = storedFileRepository;
            _FileService = fileService;
            _StorageProviderServices = storageProviderServices;
            _UserManager = userManager;
            _SettingsRepository = settingsRepository;
            _dashBoard = dashBoard;
            HttpClientFactory = httpClientFactory;
            _StoreRepository = storeRepository;
            _LnConfigProvider = lnConfigProvider;
            _torServices = torServices;
            _AppService = appService;
            _sshState = sshState;
            _eventAggregator = eventAggregator;
            _cssThemeManager = cssThemeManager;
        }

        [Route("server/maintenance")]
        public IActionResult Maintenance()
        {
            MaintenanceViewModel vm = new MaintenanceViewModel();
            vm.CanUseSSH = _sshState.CanUseSSH;
            if (!vm.CanUseSSH)
                TempData[WellKnownTempData.ErrorMessage] = "Maintenance feature requires access to SSH properly configured in BTCPayServer configuration.";
            vm.DNSDomain = this.Request.Host.Host;
            if (IPAddress.TryParse(vm.DNSDomain, out var unused))
                vm.DNSDomain = null;
            return View(vm);
        }

        [Route("server/maintenance")]
        [HttpPost]
        public async Task<IActionResult> Maintenance(MaintenanceViewModel vm, string command)
        {
            vm.CanUseSSH = _sshState.CanUseSSH;

            if (!vm.CanUseSSH)
            {
                TempData[WellKnownTempData.ErrorMessage] = "Maintenance feature requires access to SSH properly configured in BTCPayServer configuration.";
                return View(vm);
            }
            if (!ModelState.IsValid)
                return View(vm);
            if (command == "changedomain")
            {
                if (string.IsNullOrWhiteSpace(vm.DNSDomain))
                {
                    ModelState.AddModelError(nameof(vm.DNSDomain), $"Required field");
                    return View(vm);
                }
                vm.DNSDomain = vm.DNSDomain.Trim().ToLowerInvariant();
                if (vm.DNSDomain.Equals(this.Request.Host.Host, StringComparison.OrdinalIgnoreCase))
                    return View(vm);
                if (IPAddress.TryParse(vm.DNSDomain, out var unused))
                {
                    ModelState.AddModelError(nameof(vm.DNSDomain), $"This should be a domain name");
                    return View(vm);
                }
                if (vm.DNSDomain.Equals(this.Request.Host.Host, StringComparison.InvariantCultureIgnoreCase))
                {
                    ModelState.AddModelError(nameof(vm.DNSDomain), $"The server is already set to use this domain");
                    return View(vm);
                }
                var builder = new UriBuilder();
                using (var client = new HttpClient(new HttpClientHandler()
                {
                    ServerCertificateCustomValidationCallback = HttpClientHandler.DangerousAcceptAnyServerCertificateValidator
                }))
                {
                    try
                    {
                        builder.Scheme = this.Request.Scheme;
                        builder.Host = vm.DNSDomain;
                        var addresses1 = GetAddressAsync(this.Request.Host.Host);
                        var addresses2 = GetAddressAsync(vm.DNSDomain);
                        await Task.WhenAll(addresses1, addresses2);

                        var addressesSet = addresses1.GetAwaiter().GetResult().Select(c => c.ToString()).ToHashSet();
                        var hasCommonAddress = addresses2.GetAwaiter().GetResult().Select(c => c.ToString()).Any(s => addressesSet.Contains(s));
                        if (!hasCommonAddress)
                        {
                            ModelState.AddModelError(nameof(vm.DNSDomain), $"Invalid host ({vm.DNSDomain} is not pointing to this BTCPay instance)");
                            return View(vm);
                        }
                    }
                    catch (Exception ex)
                    {
                        var messages = new List<object>();
                        messages.Add(ex.Message);
                        if (ex.InnerException != null)
                            messages.Add(ex.InnerException.Message);
                        ModelState.AddModelError(nameof(vm.DNSDomain), $"Invalid domain ({string.Join(", ", messages.ToArray())})");
                        return View(vm);
                    }
                }

                var error = await RunSSH(vm, $"changedomain.sh {vm.DNSDomain}");
                if (error != null)
                    return error;

                builder.Path = null;
                builder.Query = null;
                TempData[WellKnownTempData.SuccessMessage] = $"Domain name changing... the server will restart, please use \"{builder.Uri.AbsoluteUri}\" (this page won't reload automatically)";
            }
            else if (command == "update")
            {
                var error = await RunSSH(vm, $"btcpay-update.sh");
                if (error != null)
                    return error;
                TempData[WellKnownTempData.SuccessMessage] = $"The server might restart soon if an update is available...  (this page won't reload automatically)";
            }
            else if (command == "clean")
            {
                var error = await RunSSH(vm, $"btcpay-clean.sh");
                if (error != null)
                    return error;
                TempData[WellKnownTempData.SuccessMessage] = $"The old docker images will be cleaned soon...";
            }
            else if (command == "restart")
            {
                var error = await RunSSH(vm, $"btcpay-restart.sh");
                if (error != null)
                    return error;
                TempData[WellKnownTempData.SuccessMessage] = $"BTCPay will restart momentarily.";
            }
            else
            {
                return NotFound();
            }
            return RedirectToAction(nameof(Maintenance));
        }

        private Task<IPAddress[]> GetAddressAsync(string domainOrIP)
        {
            if (IPAddress.TryParse(domainOrIP, out var ip))
                return Task.FromResult(new[] { ip });
            return Dns.GetHostAddressesAsync(domainOrIP);
        }

        public static string RunId = Encoders.Hex.EncodeData(NBitcoin.RandomUtils.GetBytes(32));
        [HttpGet]
        [Route("runid")]
        [AllowAnonymous]
        public IActionResult SeeRunId(string expected = null)
        {
            if (expected == RunId)
                return Ok();
            return BadRequest();
        }

BTCPayServer/Controllers/StorageController.cs
using System.Threading.Tasks;
using BTCPayServer.Configuration;
using BTCPayServer.Storage.Services;
using BTCPayServer.Storage.Services.Providers.FileSystemStorage;
using Microsoft.AspNetCore.Mvc;

namespace BTCPayServer.Storage
{
    [Route("Storage")]
    public class StorageController : Controller
    {
        private readonly FileService _FileService;
        private readonly string _dir;

        public StorageController(FileService fileService, DataDirectories datadirs)
        {
            _FileService = fileService;
            _dir = datadirs.TempStorageDir;
        }

        [HttpGet("{fileId}")]
        public async Task<IActionResult> GetFile(string fileId)
        {
            var url = await _FileService.GetFileUrl(Request.GetAbsoluteRootUri(), fileId);
            return new RedirectResult(url);
        }
    }
}

BTCPayServer/Views/Server/ConfiguratorService.cshtml
@model LightningWalletServices
@{
    ViewData.SetActivePageAndTitle(ServerNavPages.Services);
}

<h4>BTCPay Server Configurator</h4>
<partial name="_StatusMessage" />

<div class="row">
    <div class="col-md-6">
        <div asp-validation-summary="All" class="text-danger"></div>
    </div>
</div>

<div class="row">
    <div class="col-md-8">
        <div class="form-group">
            <p>
                <span>This page exposes information to use the configured BTCPay Server Configurator to modify this setup.</span>
            </p>
        </div>
       
            <a href="@Model.ServiceLink" target="_blank" class="form-group">
                <label>Service</label>
                <input asp-for="ServiceLink" readonly class="form-control" />
            </a>
    </div>
</div>

@section Scripts {
    @await Html.PartialAsync("_ValidationScriptsPartial")

}

BTCPayServer/Views/Server/CreateTemporaryFileUrl.cshtml
@using BTCPayServer.Controllers
@model BTCPayServer.Controllers.ServerController.CreateTemporaryFileUrlViewModel
@{
    ViewData.SetActivePageAndTitle(ServerNavPages.Services, $"Create temporary file link");
   
}


<partial name="_StatusMessage" />
<div class="row">
    <div class="col-lg-6">
        <div asp-validation-summary="All" class="text-danger"></div>
    </div>
</div>
<div class="row">
    <div class="col-lg-6">
        <form method="post">
            <div class="form-group">
                <label asp-for="IsDownload"></label>
                <input type="checkbox" class="form-check" asp-for="IsDownload"/>
                <span asp-validation-for="IsDownload" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="TimeAmount" class="control-label"></label>
                <div class="input-group">

                    <input type="number" asp-for="TimeAmount"  class="form-control">
                    <div class="input-group-append">
                        <select asp-for="TimeType" asp-items="@Html.GetEnumSelectList< ServerController.CreateTemporaryFileUrlViewModel.TmpFileTimeType>()" class="custom-select"></select>
                    </div>
                </div>
                
                <span asp-validation-for="TimeAmount" class="text-danger"></span>
                <span asp-validation-for="TimeType" class="text-danger"></span>
            </div>
            <button type="submit" class="btn btn-primary" name="command" value="Generate">Generate</button>
        </form>
    </div>
</div>

@section Scripts {
    @await Html.PartialAsync("_ValidationScriptsPartial")
}

BTCPayServer/Views/Server/CreateUser.cshtml
@model BTCPayServer.Controllers.RegisterFromAdminViewModel
@{
    ViewData.SetActivePageAndTitle(ServerNavPages.Users, $"Users - Create account");
}

<partial name="_StatusMessage"/>

<div class="row">
    <div class="col-md-6">
        <form method="post" asp-action="CreateUser">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>

            <div class="form-group">
                <label asp-for="Email"></label>
                <input asp-for="Email" required="required" class="form-control"/>
                <span asp-validation-for="Email" class="text-danger"></span>
            </div>

            <div class="form-group">
                <label asp-for="Password"></label>
                <input asp-for="Password" class="form-control"/>
                <span asp-validation-for="Password" class="text-danger"></span>
            </div>

            <div class="form-group">
                <label asp-for="ConfirmPassword"></label>
                <input asp-for="ConfirmPassword" class="form-control"/>
                <span asp-validation-for="ConfirmPassword" class="text-danger"></span>
            </div>

            @if (ViewData["AllowIsAdmin"] is true)
            {
                <div class="form-group form-check">
                    <input asp-for="IsAdmin" type="checkbox" class="form-check-input"/>
                    <label asp-for="IsAdmin" class="form-check-label"></label>
                    <span asp-validation-for="IsAdmin" class="text-danger"></span>
                </div>
            }
            

            @if (ViewData["AllowRequestEmailConfirmation"] is true)
            {
                <div class="form-group form-check">
                    <input asp-for="EmailConfirmed" type="checkbox" class="form-check-input"/>
                    <label asp-for="EmailConfirmed" class="form-check-label"></label>
                    <span asp-validation-for="EmailConfirmed" class="text-danger"></span>
                </div>
            }

            <button id="Save"  type="submit" class="btn btn-primary" name="command" value="Save">Create account</button>
        </form>
    </div>
</div>

BTCPayServer/Views/Server/DynamicDnsService.cshtml
@model BTCPayServer.Models.ServerViewModels.DynamicDnsViewModel
@{
    ViewData.SetActivePageAndTitle(ServerNavPages.Services);
}


<h4>Dynamic DNS Service</h4>
<partial name="_StatusMessage" />
@if (!this.ViewContext.ModelState.IsValid)
{
<div class="row">
    <div class="col-md-8">
        <div asp-validation-summary="All" class="text-danger"></div>
    </div>
</div>
}
<div class="row">
    <div class="col-md-8">
        <form method="post">
            <div class="form-group">
                <input type="hidden" asp-for="Modify" />
                <div class="form-group">
                    <label asp-for="Settings.ServiceUrl"></label>
                    <input id="ServiceUrl" asp-for="Settings.ServiceUrl" class="form-control" placeholder="Url" />
                    <p class="form-text text-muted">
                        Well-known Dynamic DNS providers are:
                        @for (int i = 0; i < Model.KnownServices.Length; i++)
                        {
                            <a href="#" onclick="document.getElementById('ServiceUrl').value = '@Model.KnownServices[i].Url'; return false;">@Model.KnownServices[i].Name</a><span>@(i == Model.KnownServices.Length - 1 ? "" : ",")</span>
                        }
                    </p>
                </div>
                <div class="form-group">
                    <label asp-for="Settings.Hostname"></label>
                    @if (Model.Modify)
                    {
                        <input asp-for="Settings.Hostname" class="form-control" readonly placeholder="Hostname" />
                        <p class="form-text text-muted">
                            <span>The DNS record has been refreshed: </span>
                            @if (Model.LastUpdated != null)
                            {
                                <span>@Model.LastUpdated</span>
                            }
                        </p>
                    }
                    else
                    {
                        <input asp-for="Settings.Hostname" class="form-control" placeholder="Hostname" />
                        <span asp-validation-for="Settings.Hostname" class="text-danger"></span>
                    }
                </div>
                <div class="form-group">
                    <label asp-for="Settings.Login"></label>
                    <input asp-for="Settings.Login" class="form-control" placeholder="Login" />
                </div>
                <div class="form-group">
                    <label asp-for="Settings.Password"></label>
                    <input asp-for="Settings.Password" class="form-control" placeholder="Password" />
                </div>
                @if (Model.Modify)
                {
                    <div class="form-group">
                        <label asp-for="Settings.Enabled"></label>
                        <input asp-for="Settings.Enabled" class="form-check-inline" type="checkbox" />
                    </div>
                }
                <button name="command" class="btn btn-primary" type="submit" value="Save">Save</button>
            </div>
        </form>
    </div>
</div>

BTCPayServer/Views/Server/DynamicDnsServices.cshtml
@model BTCPayServer.Models.ServerViewModels.DynamicDnsViewModel[]
@{
    ViewData.SetActivePageAndTitle(ServerNavPages.Services);
}


<h4>Dynamic DNS Settings</h4>
<partial name="_StatusMessage" />

<div class="row">
    <div class="col-md-8">
        <div class="form-group">
            <p>
                <span>
                    Dynamic DNS service allows you to have a stable DNS name pointing to your server, even if your IP address change regulary. <br />
                    This is recommended if you are hosting BTCPayServer at home and wish to have a clearnet HTTPS address to access your server.
                </span>
            </p>
            <p>Note that you need to properly configure your NAT and BTCPayServer install to get HTTPS certificate. Check the documentation for <a href="https://docs.btcpayserver.org/DynamicDNS/" target="_blank">more information</a>.</p>
        </div>
        <form method="post" asp-action="DynamicDnsService">
            <button id="AddDynamicDNS" class="btn btn-primary" type="submit"><span class="fa fa-plus"></span> Add Dynamic DNS</button>
        </form>
        <table class="table table-sm table-responsive-md">
            <thead>
                <tr>
                    <th>Hostname</th>
                    <th>Last updated</th>
                    <th style="text-align:center;">Enabled</th>
                    <th style="text-align:right">Actions</th>
                </tr>
            </thead>
            <tbody>
                @foreach (var service in Model)
                {
                    <tr>
                        <td>@service.Settings.Hostname</td>
                        <td>@service.LastUpdated</td>
                        <td style="text-align:center;">
                                @if(service.Settings.Enabled)
                                {
                                    <span class="text-success fa fa-check"></span>
                                }
                                else
                                {
                                    <span class="text-danger fa fa-times"></span>
                                }
                        </td>
                        <td  style="text-align:right"><a asp-action="DynamicDnsService" asp-route-hostname="@service.Settings.Hostname">Edit</a> <span> - </span> <a asp-action="DeleteDynamicDnsService" asp-route-hostname="@service.Settings.Hostname">Remove</a></td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

BTCPayServer/Views/Server/Logs.cshtml
@model BTCPayServer.Models.ServerViewModels.LogsViewModel
@{
    ViewData.SetActivePageAndTitle(ServerNavPages.Logs);
}

<partial name="_StatusMessage" />

<ul class="list-unstyled">
    @foreach (var file in Model.LogFiles)
    {
        <li>
            <a asp-action="LogsView" asp-route-file="@file.Name">@file.Name</a>
        </li>
    }
</ul>

<nav aria-label="..." class="w-100">
    <ul class="pagination float-left">
        <li class="page-item @(Model.LogFileOffset == 0 ? "disabled" : null)">
            <a class="page-link" asp-action="LogsView" asp-route-offset="@(Model.LogFileOffset - 5)">&laquo;</a>
        </li>
        <li class="page-item disabled">
            <span class="page-link">Showing @Model.LogFileOffset - (@(Model.LogFileOffset+Model.LogFiles.Count)) of @Model.LogFileCount</span>
        </li>
        <li class="page-item @((Model.LogFileOffset + Model.LogFiles.Count) < Model.LogFileCount ? null : "disabled")">
            <a class="page-link" asp-action="LogsView" asp-route-offset="@(Model.LogFileOffset + Model.LogFiles.Count)">&raquo;</a>
        </li>
    </ul>
</nav>

@if (!string.IsNullOrEmpty(Model.Log))
{
<br>
<br>
<br>

<pre>
@Model.Log
</pre>
}


@section Scripts {
    @await Html.PartialAsync("_ValidationScriptsPartial")
}

BTCPayServer/Views/Server/_Nav.cshtml
@using BTCPayServer.Configuration
@inject BTCPayServerOptions BTCPayServerOptions
<div class="nav flex-column nav-pills mb-4">
    <a asp-controller="Server" id="Server-@ServerNavPages.Users" class="nav-link @ViewData.IsActivePage(ServerNavPages.Users)" asp-action="ListUsers">Users</a>
    <a asp-controller="Server" id="Server-@ServerNavPages.Emails" class="nav-link @ViewData.IsActivePage(ServerNavPages.Emails)" asp-action="Emails">Email server</a>
    <a asp-controller="Server" id="Server-@ServerNavPages.Policies" class="nav-link @ViewData.IsActivePage(ServerNavPages.Policies)" asp-action="Policies">Policies</a>
    <a asp-controller="Server" id="Server-@ServerNavPages.Services" class="nav-link @ViewData.IsActivePage(ServerNavPages.Services)" asp-action="Services">Services</a>
    <a asp-controller="Server" id="Server-@ServerNavPages.Theme" class="nav-link @ViewData.IsActivePage(ServerNavPages.Theme)" asp-action="Theme">Theme</a>
    @if (BTCPayServerOptions.DockerDeployment)
    {
        <a asp-controller="Server" id="Server-@ServerNavPages.Maintenance" class="nav-link @ViewData.IsActivePage(ServerNavPages.Maintenance)" asp-action="Maintenance">Maintenance</a>
    }
    <a asp-controller="Server" id="Server-@ServerNavPages.Logs" class="nav-link @ViewData.IsActivePage(ServerNavPages.Logs)" asp-action="LogsView">Logs</a>
    <a asp-controller="Server" id="Server-@ServerNavPages.Files" class="nav-link @ViewData.IsActivePage(ServerNavPages.Files)" asp-action="Files">Files</a>
    <a asp-controller="Server" id="Server-@ServerNavPages.Plugins" class="nav-link @ViewData.IsActivePage(ServerNavPages.Plugins)" asp-action="ListPlugins">Plugins (experimental)</a>
    <vc:ui-extension-point location="server-nav" />
</div>